/********************************** (C) COPYRIGHT *******************************
* File Name          : USBH_AOA.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/01
* Description        :
 USB host example for CH559, start USB device under DP/DM and HP/HM port
 ְ֧׿ֻģʽAOAͨѶֻAPPʵ˫շ֧ͨ豸ö١
*******************************************************************************/
#include <CH559.H>
#include <stdio.h>
#include <string.h>

#pragma  NOAREGS
// ӳ򷵻״̬
#define ERR_SUCCESS         0x00    // ɹ
#define ERR_USB_CONNECT     0x15    /* ⵽USB豸¼,Ѿ */
#define ERR_USB_DISCON      0x16    /* ⵽USB豸Ͽ¼,ѾϿ */
#define ERR_USB_BUF_OVER    0x17    /* USB̫໺ */
#define ERR_USB_DISK_ERR    0x1F    /* USB洢ʧ,ڳʼʱUSB洢֧,ڶдпǴ𻵻ѾϿ */
#define ERR_USB_TRANSFER    0x20    /* NAK/STALLȸ0x20~0x2F */
#define ERR_USB_UNSUPPORT   0xFB    /*ֵ֧USB豸*/
#define ERR_USB_UNKNOWN     0xFE    /*豸*/
#define ERR_AOA_PROTOCOL    0x41    /*Э汾 */ 

/*ȡ豸*/
UINT8C  SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };
/*ȡ*/
UINT8C  SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };
/*USBַ*/
UINT8C  SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USB*/
UINT8C  SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USB IDLE*/
UINT8C  SetupSetUsbIDLE[] = { 0x21, HID_SET_IDLE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USBӿ*/
UINT8C  SetupSetUsbInterface[] = { USB_REQ_RECIP_INTERF, USB_SET_INTERFACE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*˵STALL*/
UINT8C  SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*ȡHUB*/
UINT8C  SetupGetHubDescr[] = { HUB_GET_HUB_DESCRIPTOR, HUB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_HUB, 0x00, 0x00, sizeof( USB_HUB_DESCR ), 0x00 };
/*ȡHID豸*/
UINT8C  SetupGetHIDDevReport[] = { 0x81, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_REPORT, 0x00, 0x00, 0x41, 0x00 };
//AOAȡЭ汾
UINT8C  GetProtocol[] = { 0xc0,0x33,0x00,0x00,0x00,0x00,0x02,0x00 };
//ģʽ
UINT8C  TouchAOAMode[] = { 0x40,0x35,0x00,0x00,0x00,0x00,0x00,0x00 };
/* AOA鶨 */
UINT8C  Sendlen[]= {0,4,16,35,39,53,67};
//ַID,ֻAPPصַϢ
UINT8C  StringID[] = {'W','C','H',0x00,                                                                                //manufacturer name
                      'W','C','H','U','A','R','T','D','e','m','o',0x00,                                   //model name
                      0x57,0x43,0x48,0x20,0x41,0x63,0x63,0x65,0x73,0x73,0x6f,0x72,0x79,0x20,0x54,0x65,0x73,0x74,0x00,     //description
                      '1','.','0',0x00 ,                                                                       //version
                      0x68,0x74,0x74,0x70,0x3a,0x2f,0x2f,0x77,0x63,0x68,0x2e,0x63,0x6e,0,//URI
                      0x57,0x43,0x48,0x41,0x63,0x63,0x65,0x73,0x73,0x6f,0x72,0x79,0x31,0x00                               //serial number
                     };  
//Ӧַ
UINT8C  SetStringID[]= {0x40,0x34,0x00,0x00,0x00,0x00,0x04,0x00,
                        0x40,0x34,0x00,0x00,0x01,0x00,12,0x00,
                        0x40,0x34,0x00,0x00,0x02,0x00,19,0x00,
                        0x40,0x34,0x00,0x00,0x03,0x00,4,0x00,
                        0x40,0x34,0x00,0x00,0x04,0x00,0x0E,0x00,
                        0x40,0x34,0x00,0x00,0x05,0x00,0x0E,0x00
                       };

UINT8X  UsbDevEndp0Size;              /* USB豸Ķ˵0ߴ */
/*USB豸Ϣ,CH559֧2豸*/
#define ROOT_DEV_DISCONNECT     0
#define ROOT_DEV_CONNECTED      1
#define ROOT_DEV_FAILED         2
#define ROOT_DEV_SUCCESS        3
#define DEV_TYPE_KEYBOARD   ( USB_DEV_CLASS_HID | 0x20 )
#define DEV_TYPE_MOUSE      ( USB_DEV_CLASS_HID | 0x30 )
#define DEF_AOA_DEVICE          0xF0

struct _RootHubDev
{
    UINT8   DeviceStatus;           // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
    UINT8   DeviceAddress;          // 豸USBַ
    UINT8   DeviceSpeed;            // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;             // 豸
	UINT16  DeviceVID;              // 豸VID
	UINT16  DevicePID;              // 豸PID
    UINT8   GpVar[4];               // ͨñ
} xdata RootHubDev[2];
#define HUB_MAX_PORTS   4
/*
Լ: USB豸ַ(οUSB_DEVICE_ADDR)
ֵַ  豸λ
0x02    Root-HUB0µUSB豸ⲿHUB
0x03    Root-HUB1µUSB豸ⲿHUB
0x1x    Root-HUB0µⲿHUBĶ˿xµUSB豸,xΪ1~n
0x2x    Root-HUB1µⲿHUBĶ˿xµUSB豸,xΪ1~n
*/
struct _DevOnHubPort
{
    UINT8   DeviceStatus;           // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
    UINT8   DeviceAddress;          // 豸USBַ
    UINT8   DeviceSpeed;            // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;             // 豸
//.....    struct  _Endp_Attr   Endp_Attr[4];   //˵,֧4˵
    UINT8   GpVar;                  // ͨñ
} xdata DevOnHubPort[2][HUB_MAX_PORTS];  // ٶ:2ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)

UINT8X  RxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0000 ;  // IN, must even address
UINT8X  TxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0040 ;  // OUT, must even address
#define pSetupReq   ((PXUSB_SETUP_REQ)TxBuffer)
UINT8X  COM_BUF[200];                              //ٹų64ֽڵ
bit     RootHubId;                 // ǰڲroot-hub˿ں:0=HUB0,1=HUB1
bit     FoundNewDev;
#pragma NOAREGS
#define WAIT_USB_TOUT_200US     200  // ȴUSBжϳʱʱ200uS@Fsys=12MHz
void    mDelayuS( UINT16 n );                          // uSΪλʱ
void    mDelaymS( UINT16 n );                          // mSΪλʱ
void    DisableRootHubPort( UINT8 RootHubIndex );      // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
UINT8   AnalyzeRootHub( void );                        // ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
void    SetHostUsbAddr( UINT8 addr );                  // USBǰUSB豸ַ
void    SetUsbSpeed( UINT8 FullSpeed );                // õǰUSBٶ
void    ResetRootHubPort( UINT8 RootHubIndex );        // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ
UINT8   EnableRootHubPort( UINT8 RootHubIndex );       // ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
void    SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex );// HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
UINT8   WaitUSB_Interrupt( void );                     // ȴUSBж
// CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout );  // endp_pid: 4λtoken_pid, 4λǶ˵ַ
UINT8   HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen );  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȷرReqLenָֽڱ
void    CopySetupReqPkg( PUINT8C pReqPkt );            // ƿƴ
UINT8   CtrlGetDeviceDescr( void );                    // ȡ豸,TxBuffer
UINT8   CtrlGetConfigDescr( void );                    // ȡ,TxBuffer
UINT8   CtrlSetUsbAddress( UINT8 addr );               // USB豸ַ
UINT8   CtrlSetUsbConfig( UINT8 cfg );                 // USB豸
UINT8   CtrlSetUsbIntercace( UINT8 cfg );              // USB豸ӿ
UINT8   CtrlClearEndpStall( UINT8 endp );              // ˵STALL
UINT8   CtrlGetHubDescr( void );                       // ȡHUB,TxBuffer
UINT8   HubGetPortStatus( UINT8 HubPortIndex );        // ѯHUB˿״̬,TxBuffer
UINT8   HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿
UINT8   HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿
UINT8   AnalyzeHidIntEndp( PUINT8X buf );              // зHIDж϶˵ĵַ
UINT8   AnalyzeBulkEndp( PUINT8X buf,UINT8 RootHubIndex ) ;//RootHUBµ˵
UINT8   TouchStartAOA(void);                           // AOAģʽ
UINT8   InitRootDevice( UINT8 RootHubIndex );          // ʼָROOT-HUB˿ڵUSB豸
// : HUB˿ں0/1
UINT8   EnumAllRootDevice( void );                     // öROOT-HUB˿ڵUSB豸
UINT8   InitDevOnHub( UINT8 RootHubIndex, UINT8 HubPortIndex );  // ʼöⲿHUBĶUSB豸
UINT8   EnumHubPort( UINT8 RootHubIndex );             // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼ʼUSB豸
UINT8   EnumAllHubPort( void );                        // öROOT-HUB˿ⲿHUBĶUSB豸
UINT16  SearchTypeDevice( UINT8 type );                // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
// 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
void    mInitSTDIO( void );                            // Ϊprintfgetkeyʼ
void    InitUSB_Host( void );                          // ʼUSB

void AnalyzeEp(void);
UINT8 adbEp[2];
UINT8 adbAddr[2];
UINT8   aoaAddr[2];   //aoaͨŶ˵
UINT8  aoaEp[2];
UINT8 ADBBlukTranEpSize;
UINT8 adbInput(void);
UINT8 adbOutput(void);
UINT8   AOABlukTranEpSize;
//#define   FREQ_SYS    12000000                       // ϵͳƵ12MHz
/*******************************************************************************
* Function Name  : mDelayus(UNIT16 n)
* Description    : usʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void    mDelayuS( UINT16 n )                           // uSΪλʱ
{
    while ( n )                                        // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
    {
        ++ SAFE_MOD;                                   // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef  FREQ_SYS
#if     FREQ_SYS >= 14000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 16000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 18000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 20000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 22000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 24000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 26000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 28000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 30000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 32000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 34000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 36000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 38000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 40000000
        ++ SAFE_MOD;
#endif
#endif
        -- n;
    }
}
/*******************************************************************************
* Function Name  : mDelayms(UNIT16 n)
* Description    : msʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void    mDelaymS( UINT16 n )                              // mSΪλʱ
{
    while ( n )
    {
        mDelayuS( 1000 );
        -- n;
    }
}
/*******************************************************************************
* Function Name  : DisableRootHubPort(UINT8 RootHubIndex)
* Description    : رHUB˿
* Input          : UINT8 RootHubIndex ָROOT_HUB
* Output         : None
* Return         : None
*******************************************************************************/
void    DisableRootHubPort( UINT8 RootHubIndex )          // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
{
    RootHubDev[ RootHubIndex ].DeviceStatus = ROOT_DEV_DISCONNECT;
    RootHubDev[ RootHubIndex ].DeviceAddress = 0x00;
    if ( RootHubIndex == 1 )
    {
        UHUB1_CTRL = 0x00;                                // йHUB1Ŀ,ʵϲҪ
    }
    else
    {
        UHUB0_CTRL = 0x00;                                // йHUB0Ŀ,ʵϲҪ
    }
}
/*******************************************************************************
* Function Name  : AnalyzeRootHub(void)
* Description    : ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
                   豸γ,еDisableRootHubPort(),˿ڹر,¼,Ӧ˿ڵ״̬λ
* Input          : None
* Output         : None
* Return         : ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
*******************************************************************************/
UINT8   AnalyzeRootHub( void )
{
    UINT8   s;
    s = ERR_SUCCESS;
    if ( USB_HUB_ST & bUHS_H0_ATTACH )                         // 豸ڣHUB0
    {
        if ( RootHubDev[0].DeviceStatus == ROOT_DEV_DISCONNECT // ⵽豸
                || ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )      // ⵽豸,δ,˵Ǹղ
        {
            DisableRootHubPort( 0 );                           // رն˿
//          RootHubDev[0].DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
            RootHubDev[0].DeviceStatus = ROOT_DEV_CONNECTED;   //ӱ־
            printf( "HUB 0 dev in\n" );
            s = ERR_USB_CONNECT;
        }
    }
    else if ( RootHubDev[0].DeviceStatus >= ROOT_DEV_CONNECTED )//⵽豸γ
    {
        DisableRootHubPort( 0 );                               // رն˿
        printf( "HUB 0 dev out\n" );
        //UH_SETUP &= ~bUH_SOF_EN;
        if ( s == ERR_SUCCESS )
        {
            s = ERR_USB_DISCON;                                //豸Ͽ־
        }
    }
    if ( USB_HUB_ST & bUHS_H1_ATTACH )                         // 豸ڣHUB1
    {
        if ( RootHubDev[1].DeviceStatus == ROOT_DEV_DISCONNECT // ⵽豸
                || ( UHUB1_CTRL & bUH_PORT_EN ) == 0x00 )      // ⵽豸,δ,˵Ǹղ
        {
            DisableRootHubPort( 1 );                           // رն˿
//          RootHubDev[1].DeviceSpeed = USB_HUB_ST & bUHS_HM_LEVEL ? 0 : 1;
            RootHubDev[1].DeviceStatus = ROOT_DEV_CONNECTED;   //ӱ־
            printf( "HUB 1 dev in\n" );
            s = ERR_USB_CONNECT;
        }
    }
    else if ( RootHubDev[1].DeviceStatus >= ROOT_DEV_CONNECTED )//⵽豸γ
    {
        DisableRootHubPort( 1 );                                // رն˿
        //UH_SETUP &= ~bUH_SOF_EN;
        printf( "HUB 1 dev out\n" );
        if ( s == ERR_SUCCESS )
        {
            s = ERR_USB_DISCON;
        }
    }
//  UIF_DETECT = 0;                                             // жϱ־
    return( s );
}
/*******************************************************************************
* Function Name  : SetHostUsbAddr
* Description    : USBǰUSB豸ַ
* Input          : UINT8 addr
* Output         : None
* Return         : None
*******************************************************************************/
void    SetHostUsbAddr( UINT8 addr )
{
    USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | addr & 0x7F;
}
/*******************************************************************************
* Function Name  : SetUsbSpeed
* Description    : õǰUSBٶ
* Input          : UINT8 FullSpeed
* Output         : None
* Return         : None
*******************************************************************************/
void    SetUsbSpeed( UINT8 FullSpeed )
{
    if ( FullSpeed )                                            // ȫ
    {
        USB_CTRL &= ~ bUC_LOW_SPEED;                            // ȫ
        UH_SETUP &= ~ bUH_PRE_PID_EN;                           // ֹPRE PID
    }
    else
    {
        USB_CTRL |= bUC_LOW_SPEED;                              // 
    }
}
/*******************************************************************************
* Function Name  : ResetRootHubPort( UINT8 RootHubIndex )
* Description    : ⵽豸,λ,Ϊö豸׼,ΪĬΪȫ
* Input          : UINT8 RootHubIndex ָ˿
* Output         : None
* Return         : None
*******************************************************************************/
void    ResetRootHubPort( UINT8 RootHubIndex )
{
    UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;                        //USB豸Ķ˵0ߴ
    SetHostUsbAddr( 0x00 );
	RootHubDev[ RootHubIndex ].DeviceAddress = 0x00;
	if ( RootHubIndex == 1 )
	{ 
		UHUB1_CTRL = 0x00;                                      // йHUB1Ŀ,ʵϲҪ
	}
	else
	{
		UHUB0_CTRL = 0x00;                                       // йHUB0Ŀ,ʵϲҪ
	}
			
    SetUsbSpeed( 1 );                                            // ĬΪȫ
    if ( RootHubIndex == 1 )
    {
        UHUB1_CTRL = UHUB1_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;// ĬΪȫ,ʼλ
        mDelaymS( 15 );                                          // λʱ10mS20mS
        UHUB1_CTRL = UHUB1_CTRL & ~ bUH_BUS_RESET;               // λ
    }
    else
    {
        UHUB0_CTRL = UHUB0_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;// ĬΪȫ,ʼλ
        mDelaymS( 15 );                                          // λʱ10mS20mS
        UHUB0_CTRL = UHUB0_CTRL & ~ bUH_BUS_RESET;               // λ
    }
    mDelayuS( 250 );
    UIF_DETECT = 0;                                              // жϱ־
}
/*******************************************************************************
* Function Name  : EnableRootHubPort( UINT8 RootHubIndex )
* Description    : ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
* Input          : UINT8 RootHubIndex ָ˿
* Output         : None
* Return         : ERR_SUCCESSΪ⵽,ERR_USB_DISCONΪ
*******************************************************************************/
UINT8   EnableRootHubPort( UINT8 RootHubIndex )
{
    if ( RootHubDev[ RootHubIndex ].DeviceStatus < ROOT_DEV_CONNECTED )
    {
        RootHubDev[ RootHubIndex ].DeviceStatus = ROOT_DEV_CONNECTED;
    }
    if ( RootHubIndex == 1 )
    {
        if ( USB_HUB_ST & bUHS_H1_ATTACH )                       // HUB1豸
        {
            if ( ( UHUB1_CTRL & bUH_PORT_EN ) == 0x00 )          // δʹ
            {
                RootHubDev[1].DeviceSpeed = USB_HUB_ST & bUHS_HM_LEVEL ? 0 : 1;
                if ( RootHubDev[1].DeviceSpeed == 0 )
                {
                    UHUB1_CTRL |= bUH_LOW_SPEED;                 // 
                }
            }
            UHUB1_CTRL |= bUH_PORT_EN;                           //ʹHUB1˿
            return( ERR_SUCCESS );
        }
    }
    else
    {
        if ( USB_HUB_ST & bUHS_H0_ATTACH )                      // HUB0豸
        {
            if ( ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )         // δʹ
            {
                RootHubDev[0].DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
                if ( RootHubDev[0].DeviceSpeed == 0 )
                {
                    UHUB0_CTRL |= bUH_LOW_SPEED;                // 
                }
            }
            UHUB0_CTRL |= bUH_PORT_EN;                          //ʹHUB0˿
            return( ERR_SUCCESS );
        }
    }
    return( ERR_USB_DISCON );
}
/*******************************************************************************
* Function Name  : SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex )
* Description    : ѡҪHUB
* Input          : UINT8 RootHubIndex HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
                   UINT8 HubPortIndex ѡָROOT-HUB˿ڵⲿHUBָ˿
* Output         : None
* Return         : None
*******************************************************************************/
void    SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex )
{
    if ( HubPortIndex )                                          // ѡָROOT-HUB˿ڵⲿHUBָ˿
    {
        SetHostUsbAddr( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceAddress );// USBǰUSB豸ַ
        SetUsbSpeed( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceSpeed );// õǰUSBٶ
        if ( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceSpeed == 0 )// ͨⲿHUBUSB豸ͨѶҪǰID
        {
            UH_SETUP |= bUH_PRE_PID_EN;                          // PRE PID
            mDelayuS(100);
        }
    }
    else                                                         // ѡָROOT-HUB˿
    {
        SetHostUsbAddr( RootHubDev[RootHubIndex].DeviceAddress );// USBǰUSB豸ַ
        SetUsbSpeed( RootHubDev[RootHubIndex].DeviceSpeed );     // õǰUSBٶ
    }
    RootHubId = RootHubIndex ? 1 : 0;
}
/*******************************************************************************
* Function Name  : WaitUSB_Interrupt
* Description    : ȴUSBж
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ݽջ߷ͳɹ
                   ERR_USB_UNKNOWN ݽջ߷ʧ
*******************************************************************************/
UINT8   WaitUSB_Interrupt( void )
{
    UINT16  i;
    for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
    {
        ;
    }
    return( UIF_TRANSFER ? ERR_SUCCESS : ERR_USB_UNKNOWN );
}
/*******************************************************************************
* Function Name  : USBHostTransact
* Description    : CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
                   ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
* Input          : UINT8 endp_pid ƺ͵ַ  endp_pid: 4λtoken_pid, 4λǶ˵ַ
                   UINT8 tog      ͬ־
                   UINT16 timeout ʱʱ
* Output         : None
* Return         : ERR_USB_UNKNOWN ʱӲ쳣
                   ERR_USB_DISCON  豸Ͽ
                   ERR_USB_CONNECT 豸
                   ERR_SUCCESS     
*******************************************************************************/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout )
{
    UINT8   TransRetry;
// #define TransRetry  UEP0_T_LEN                                    // Լڴ
    UINT8  r;
    UINT16  i;
    UH_RX_CTRL = tog;
    UH_TX_CTRL =tog ;
    TransRetry = 0;
    do
    {
//      LED_TMP = 0;
        UH_EP_PID = endp_pid;                                    // ָPIDĿĶ˵
        UIF_TRANSFER = 0;                                        // 
//      s = WaitUSB_Interrupt( );
        for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
        {
            ;
        }
        UH_EP_PID = 0x00;                                        // ֹͣUSB
//      LED_TMP = 1;
//      if ( s != ERR_SUCCESS ) return( s );                     // жϳʱ,Ӳ쳣
        if ( UIF_TRANSFER == 0 )
        {
            return( ERR_USB_UNKNOWN );
        }
//         if ( UIF_DETECT )                                        // USB豸¼
//         {
// //          mDelayuS( 200 );                                     // ȴ
// //             UIF_DETECT = 0;                                      // жϱ־
//             s = AnalyzeRootHub( );                               // ROOT-HUB״̬
//             if ( s == ERR_USB_CONNECT )
//             {
//                 FoundNewDev = 1;
//             }
//             if ( (RootHubDev[RootHubId].DeviceStatus == ROOT_DEV_DISCONNECT)||(CH559DiskStatus == DISK_DISCONNECT) )
//             {
//                 return( ERR_USB_DISCON );                        // USB豸Ͽ¼
//             }
//             if ( (RootHubDev[RootHubId].DeviceStatus == ROOT_DEV_CONNECTED)||(CH559DiskStatus == DISK_CONNECT) )
//             {
//                 return( ERR_USB_CONNECT );                       // USB豸¼
//             }
// //          if ( ( USB_HUB_ST & bUHS_H0_ATTACH ) == 0x00 ) return( ERR_USB_DISCON );// USB豸Ͽ¼
//             mDelayuS( 200 );                                     // ȴ
//         }
        if ( UIF_TRANSFER )                                      // 
        {
            if ( U_TOG_OK )
            {
                return( ERR_SUCCESS );
            }
            r = USB_INT_ST & MASK_UIS_H_RES;                     // USB豸Ӧ״̬
            if ( r == USB_PID_STALL )
            {
                return( r | ERR_USB_TRANSFER );
            }
            if ( r == USB_PID_NAK )
            {
                if ( timeout == 0 )
                {
                    return( r | ERR_USB_TRANSFER );
                }
                if ( timeout < 0xFFFF )
                {
                    timeout --;
                }
                -- TransRetry;
            }
            else switch ( endp_pid >> 4 )
                {
                case USB_PID_SETUP:
                case USB_PID_OUT:
                    if ( U_TOG_OK )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( r == USB_PID_ACK )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( r == USB_PID_STALL || r == USB_PID_NAK )
                    {
                        return( r | ERR_USB_TRANSFER );
                    }
                    if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );          // ǳʱ/,Ӧ
                    }
                    break;                                       // ʱ
                case USB_PID_IN:
                    if ( U_TOG_OK )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( tog ? r == USB_PID_DATA1 : r == USB_PID_DATA0 )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( r == USB_PID_STALL || r == USB_PID_NAK )
                    {
                        return( r | ERR_USB_TRANSFER );
                    }
                    if ( r == USB_PID_DATA0 && r == USB_PID_DATA1 )// ͬ趪
                    {
                    }                                            // ͬ
                    else if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );          // ǳʱ/,Ӧ
                    }
                    break;                                       // ʱ
                default:
                    return( ERR_USB_UNKNOWN );                   // ܵ
                    break;
                }
        }
        else                                                     // ж,Ӧ÷
        {
            USB_INT_FG = 0xFF;                                   //жϱ־
        }
        mDelayuS( 15 );
    }
    while ( ++ TransRetry < 3 );
    return( ERR_USB_TRANSFER );                                  // Ӧʱ
}
/*******************************************************************************
* Function Name  : HostCtrlTransfer
* Description    : ִпƴ,8ֽpSetupReq,DataBufΪѡշ
* Input          : PUINT8X DataBuf Ҫպͷ,ôDataBufָЧڴź
                   PUINT8 RetLen  ʵʳɹշܳȱRetLenָֽڱ
* Output         : None
* Return         : ERR_USB_BUF_OVER IN״̬׶γ
                   ERR_SUCCESS     ݽɹ
                   ״̬
*******************************************************************************/
UINT8  HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen )
{
    UINT16  RemLen  = 0;
    UINT8   s, RxLen, RxCnt, TxCnt;
    PUINT8  pBuf;
    PUINT8  xdata   pLen;
    pBuf = DataBuf;
    pLen = RetLen;
    mDelayuS( 200 );
    if ( pLen )
    {
        *pLen = 0;                                                // ʵʳɹշܳ
    }
    UH_TX_LEN = sizeof( USB_SETUP_REQ );
    s = USBHostTransact( USB_PID_SETUP << 4 | 0x00, 0x00, 200000/20 );// SETUP׶,200mSʱ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UH_RX_CTRL = UH_TX_CTRL = bUH_R_TOG | bUH_R_AUTO_TOG | bUH_T_TOG | bUH_T_AUTO_TOG;// ĬDATA1
    UH_TX_LEN = 0x01;                                            // Ĭݹ״̬׶ΪIN
    RemLen = (pSetupReq -> wLengthH << 8)|( pSetupReq -> wLengthL);
    if ( RemLen && pBuf )                                        // Ҫշ
    {
        if ( pSetupReq -> bRequestType & USB_REQ_TYP_IN )        // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                s = USBHostTransact( USB_PID_IN << 4 | 0x00, UH_RX_CTRL, 200000/20 );// IN
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RxLen = USB_RX_LEN < RemLen ? USB_RX_LEN : RemLen;
                RemLen -= RxLen;
                if ( pLen )
                {
                    *pLen += RxLen;                             // ʵʳɹշܳ
                }

                for ( RxCnt = 0; RxCnt != RxLen; RxCnt ++ )
                {
                    *pBuf = RxBuffer[ RxCnt ];
                    pBuf ++;
                }
                if ( USB_RX_LEN == 0 || ( USB_RX_LEN & ( UsbDevEndp0Size - 1 ) ) )
                {
                    break;                                      // ̰
                }
            }
            UH_TX_LEN = 0x00;                                   // ״̬׶ΪOUT
        }
        else                                                    // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                UH_TX_LEN = RemLen >= UsbDevEndp0Size ? UsbDevEndp0Size : RemLen;

                for ( TxCnt = 0; TxCnt != UH_TX_LEN; TxCnt ++ )
                {
                    TxBuffer[ TxCnt ] = *pBuf;
                    pBuf ++;
                }
                s = USBHostTransact( USB_PID_OUT << 4 | 0x00, UH_TX_CTRL, 200000/20 );// OUT
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RemLen -= UH_TX_LEN;
                if ( pLen )
                {
                    *pLen += UH_TX_LEN;                        // ʵʳɹշܳ
                }
            }
//          UH_TX_LEN = 0x01;                                  // ״̬׶ΪIN
        }
    }
    mDelayuS( 200 );
    s = USBHostTransact( ( UH_TX_LEN ? USB_PID_IN << 4 | 0x00: USB_PID_OUT << 4 | 0x00 ), bUH_R_TOG | bUH_T_TOG, 200000/20 );  // STATUS׶
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( UH_TX_LEN == 0 )
    {
        return( ERR_SUCCESS );                                  // ״̬OUT
    }
    if ( USB_RX_LEN == 0 )
    {
        return( ERR_SUCCESS );                                  // ״̬IN,IN״̬ݳ
    }
    return( ERR_USB_BUF_OVER );                                 // IN״̬׶δ
}
/*******************************************************************************
* Function Name  : CopySetupReqPkg
* Description    : ƿƴ
* Input          : PUINT8C pReqPkt ַ
* Output         : None
* Return         : None
*******************************************************************************/
void    CopySetupReqPkg( PUINT8C pReqPkt )                      // ƿƴ
{
    UINT8   i;
    for ( i = 0; i != sizeof( USB_SETUP_REQ ); i ++ )
    {
        ((PUINT8X)pSetupReq)[ i ] = *pReqPkt;
        pReqPkt ++;
    }
}
/*******************************************************************************
* Function Name  : CtrlGetDeviceDescr
* Description    : ȡ豸,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetDeviceDescr( void )
{
    UINT8   s;
    UINT8   len;
    UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;
    CopySetupReqPkg( SetupGetDevDescr );
    s = HostCtrlTransfer( COM_BUF, &len );                    // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UsbDevEndp0Size = ( (PXUSB_DEV_DESCR)COM_BUF ) -> bMaxPacketSize0;// ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndp0Sizeټ
    if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                            // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlGetConfigDescr
* Description    : ȡ,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetConfigDescr( void )
{
    UINT8   s;
    UINT8D  len;
    CopySetupReqPkg( SetupGetCfgDescr );
    s = HostCtrlTransfer( COM_BUF, &len );                     // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                             // سȴ
    }
    len = ( (PXUSB_CFG_DESCR)COM_BUF ) -> wTotalLengthL;
    CopySetupReqPkg( SetupGetCfgDescr );
    pSetupReq -> wLengthL = len;                                // ܳ
    s = HostCtrlTransfer( COM_BUF, &len );                      // ִпƴ䣨ʱܳ64ֽڣCOM_BUFУ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL || len < ( (PXUSB_CFG_DESCR)COM_BUF ) -> wTotalLengthL )
    {
        return( ERR_USB_BUF_OVER );                             // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlSetUsbAddress
* Description    : USB豸ַ
* Input          : UINT8 addr 豸ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbAddress( UINT8 addr )
{
    UINT8   s;
    CopySetupReqPkg( SetupSetUsbAddr );
    pSetupReq -> wValueL = addr;                                 // USB豸ַ
    s = HostCtrlTransfer( NULL, NULL );                          // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    SetHostUsbAddr( addr );                                      // USBǰUSB豸ַ
    mDelaymS( 10 );                                              // ȴUSB豸ɲ
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlSetUsbConfig
* Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbConfig( UINT8 cfg )
{
    CopySetupReqPkg( SetupSetUsbConfig );
    pSetupReq -> wValueL = cfg;                                 // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlSetUsbIDLE
* Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbIDLE( UINT8 idle )
{
    CopySetupReqPkg( SetupSetUsbIDLE );
    pSetupReq -> wIndexL = idle;                                 // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlSetUsbIntercace
* Description    : USB豸ӿ
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbIntercace( UINT8 cfg )
{
    CopySetupReqPkg( SetupSetUsbInterface );
    pSetupReq -> wValueL = cfg;                                 // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlClearEndpStall
* Description    : ˵STALL
* Input          : UINT8 endp       ˵ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlClearEndpStall( UINT8 endp )
{
    CopySetupReqPkg( SetupClrEndpStall );                       // ˵Ĵ
    pSetupReq -> wIndexL = endp;                                // ˵ַ
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlGetHIDDeviceReport
* Description    : ȡHID豸,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           
*******************************************************************************/
UINT8  CtrlGetHIDDeviceReport( void )
{
    UINT8   s;
    UINT8   len;
    UINT8 tmp[]= {0x21,0x0a,0x00,0x00,0x00,0x00,0x00,0x00};
    for ( s = 0; s != sizeof( tmp ); s ++ )
    {
        ((PUINT8X)pSetupReq)[ s ] = tmp[s];
    }
    s = HostCtrlTransfer( COM_BUF, &len );                     // ִпƴ
//    if ( s != ERR_SUCCESS )
//    {
//        return( s );
//    }
    CopySetupReqPkg( SetupGetHIDDevReport );
    s = HostCtrlTransfer( COM_BUF, &len );                     // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                             // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlGetHubDescr
* Description    : ȡHUB,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ɹ
                   ERR_USB_BUF_OVER ȴ
*******************************************************************************/
UINT8   CtrlGetHubDescr( void )
{
    UINT8   s;
    UINT8D  len;
    CopySetupReqPkg( SetupGetHubDescr );
    s = HostCtrlTransfer( TxBuffer, &len );                      // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetHubDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                             // ȴ
    }
//  if ( len < 4 ) return( ERR_USB_BUF_OVER );                  // ȴ
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : HubGetPortStatus
* Description    : ѯHUB˿״̬,TxBuffer
* Input          : UINT8 HubPortIndex
* Output         : None
* Return         : ERR_SUCCESS ɹ
                   ERR_USB_BUF_OVER ȴ
*******************************************************************************/
UINT8   HubGetPortStatus( UINT8 HubPortIndex )
{
    UINT8   s;
    UINT8D  len;
    pSetupReq -> bRequestType = HUB_GET_PORT_STATUS;
    pSetupReq -> bRequest = HUB_GET_STATUS;
    pSetupReq -> wValueL = 0x00;
    pSetupReq -> wValueH = 0x00;
    pSetupReq -> wIndexL = HubPortIndex;
    pSetupReq -> wIndexH = 0x00;
    pSetupReq -> wLengthL = 0x04;
    pSetupReq -> wLengthH = 0x00;
    s = HostCtrlTransfer( TxBuffer, &len );                     // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < 4 )
    {
        return( ERR_USB_BUF_OVER );                             // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : HubSetPortFeature
* Description    : HUB˿
* Input          : UINT8 HubPortIndex                           //HUB˿
                   UINT8 FeatureSelt                            //HUB˿
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           
*******************************************************************************/
UINT8   HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{
    pSetupReq -> bRequestType = HUB_SET_PORT_FEATURE;
    pSetupReq -> bRequest = HUB_SET_FEATURE;
    pSetupReq -> wValueL = FeatureSelt;
    pSetupReq -> wValueH = 0x00;
    pSetupReq -> wIndexL = HubPortIndex;
    pSetupReq -> wIndexH = 0x00;
    pSetupReq -> wLengthL = 0x00;
    pSetupReq -> wLengthH = 0x00;
    return( HostCtrlTransfer( NULL, NULL ) );  // ִпƴ
}
/*******************************************************************************
* Function Name  : HubClearPortFeature
* Description    : HUB˿
* Input          : UINT8 HubPortIndex                           //HUB˿
                   UINT8 FeatureSelt                            //HUB˿
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           
*******************************************************************************/
UINT8   HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{
    pSetupReq -> bRequestType = HUB_CLEAR_PORT_FEATURE;
    pSetupReq -> bRequest = HUB_CLEAR_FEATURE;
    pSetupReq -> wValueL = FeatureSelt;
    pSetupReq -> wValueH = 0x00;
    pSetupReq -> wIndexL = HubPortIndex;
    pSetupReq -> wIndexH = 0x00;
    pSetupReq -> wLengthL = 0x00;
    pSetupReq -> wLengthH = 0x00;
    return( HostCtrlTransfer( NULL, NULL ) );  // ִпƴ
}

/*******************************************************************************
* Function Name  : AnalyzeHidIntEndp
* Description    : зHIDж϶˵ĵַ
* Input          : PUINT8X buf       ݻַ
* Output         : None
* Return         : ж϶˵ַ
*******************************************************************************/
UINT8   AnalyzeHidIntEndp( PUINT8X buf )
{
    UINT8   i, s, l;
    s = 0;
    for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLengthL; i += l )             // ж϶˵,ͽӿ
    {
        if ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP  // Ƕ˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_INTER// ж϶˵
                && ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK ) )// IN˵
        {
            s = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;// ж϶˵ĵַ
            break;                                                                   // ԸҪwMaxPacketSizebInterval
        }
        l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;                                // ǰ,
        if ( l > 16 )
        {
            break;
        }
    }
    return( s );
}

/*******************************************************************************
* Function Name  : AnalyzeBulkEndp,ڷRootHub
* Description    : ˵,GpVar[0]GpVar[1]ϴ˵㡣GpVar[2]GpVar[3]´˵
* Input          : bufݻַ   HubPortIndex0ʾHUB0ʾⲿHUBµĶ˿ں
* Output         : None
* Return         : 0
*******************************************************************************/
UINT8   AnalyzeBulkEndp( PUINT8X buf,UINT8 RootHubIndex ) 
{
    UINT8   i, s1,s2, l;
    s1 = 0;s2 = 2;

	memset( RootHubDev[RootHubIndex].GpVar,0,sizeof(RootHubDev[RootHubIndex].GpVar) );  //

    for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLengthL; i += l )       // ж϶˵,ͽӿ
    {
        if ( (( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP)     // Ƕ˵
                && ((( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_BULK))  // 

        {

			if(( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK )
				RootHubDev[RootHubIndex].GpVar[s1++] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
			else
				RootHubDev[RootHubIndex].GpVar[s2++] = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;
	
			if(s1 == 2) s1 = 1;
			if(s2 == 4) s2 = 3;			
		}
        l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;                          // ǰ,
        if ( l > 16 )
        {
            break;
        }
    }
    return( 0 );
}

//AOAģʽ
UINT8 TouchStartAOA(void)
{
	UINT8 len,s,i,Num;
    //ȡЭ汾
    CopySetupReqPkg( GetProtocol );
    s = HostCtrlTransfer( COM_BUF, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
	if(COM_BUF[0]<2) return  ERR_AOA_PROTOCOL;

    //ַ
    for(i=0; i<6; i++)
    {
        Num=Sendlen[i];
        CopySetupReqPkg(&SetStringID[8*i]);
        s = HostCtrlTransfer( &StringID[Num], &len );  // ִпƴ
        if ( s != ERR_SUCCESS )
        {
            return( s );
        }
    }	

    CopySetupReqPkg(TouchAOAMode);
    s = HostCtrlTransfer( COM_BUF, &len );  // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    return ERR_SUCCESS;	
}

/*******************************************************************************
* Function Name  : InitRootDevice
* Description    : ʼָROOT-HUB˿ڵUSB豸
* Input          : UINT8 RootHubIndex ָ˿ڣHUB˿ں0/1
* Output         : None
* Return         :
*******************************************************************************/
UINT8   InitRootDevice( UINT8 RootHubIndex )
{
    UINT8   i, s, cfg, dv_cls, if_cls;
	UINT8  touchaoatm = 0;
    UINT8  retry=0;
    printf( "Reset root hub %1d# port\n", (UINT16)RootHubIndex );
    while(retry<10)
    {
        mDelaymS( 100*retry );
        retry++;
        ResetRootHubPort( RootHubIndex );                              // ⵽豸,λӦ˿ڵUSB
        for ( i = 0, s = 0; i < 100; i ++ )                            // ȴUSB豸λ,100mSʱ
        {
            mDelaymS( 1 );
            if ( EnableRootHubPort( RootHubIndex ) == ERR_SUCCESS )    // ʹROOT-HUB˿
            {
                i = 0;
                s ++;                                                  // ʱȴUSB豸Ӻȶ
                if ( s > 10*retry )
                {
                    break;                                             // Ѿȶ15mS
                }
            }
        }
        if ( i )                                                       // λ豸û
        {
            DisableRootHubPort( RootHubIndex );
            printf( "Disable root hub %1d# port because of disconnect\n", (UINT16)RootHubIndex );
//         return( ERR_USB_DISCON );
            continue;
        }
        SelectHubPort( RootHubIndex, 0 );
        printf( "GetDevDescr: " );
        s = CtrlGetDeviceDescr( );                                     // ȡ豸
        if ( s == ERR_SUCCESS )
        {
            for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ )
            {
                printf( "x%02X ", (UINT16)( COM_BUF[i] ) );
            }
            printf( "\n" );                                            // ʾ
			
			RootHubDev[RootHubIndex].DeviceVID=(((UINT16)((PXUSB_DEV_DESCR)COM_BUF)->idVendorH)<<8 ) + ((PXUSB_DEV_DESCR)COM_BUF)->idVendorL; //VID PIDϢ
			RootHubDev[RootHubIndex].DevicePID=(((UINT16)((PXUSB_DEV_DESCR)COM_BUF)->idProductH)<<8 ) + ((PXUSB_DEV_DESCR)COM_BUF)->idProductL;
            dv_cls = ( (PXUSB_DEV_DESCR)COM_BUF ) -> bDeviceClass;    // 豸
            s = CtrlSetUsbAddress( RootHubIndex + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );// USB豸ַ,RootHubIndexԱ֤2HUB˿ڷ䲻ͬĵַ
            if ( s == ERR_SUCCESS )
            {
                RootHubDev[RootHubIndex].DeviceAddress = RootHubIndex + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL;  // USBַ
                printf( "GetCfgDescr: " );
                s = CtrlGetConfigDescr( );                             // ȡ
                if ( s == ERR_SUCCESS )
                {
                    cfg = ( (PXUSB_CFG_DESCR)COM_BUF ) -> bConfigurationValue;
                    for ( i = 0; i < ( (PXUSB_CFG_DESCR)COM_BUF ) -> wTotalLengthL; i ++ )
                    {
                        printf( "x%02X ", (UINT16)( COM_BUF[i] ) );
                    }
                    printf("\n");
					
				if(i >= (9+9+14))//ֻ֧AOA˵
                {
                  aoaAddr[0] = TxBuffer[20];//洢AOA˵źʹС
                  aoaAddr[1] = TxBuffer[27];
                  AOABlukTranEpSize = TxBuffer[28];									
                  adbAddr[0] = 0xff;
                  adbAddr[1] = 0xff;
                  ADBBlukTranEpSize = 0;									
                }	
                if(i == (9+9+14+9+14))//֧ADB˵
                {
                  adbAddr[0] = TxBuffer[43];//洢ADB˵źʹС
                  adbAddr[1] = TxBuffer[50];
                  ADBBlukTranEpSize = TxBuffer[51];									
                }
                    //,ȡ˵/˵ַ/˵С,±endp_addrendp_size
                    if_cls = ( (PXUSB_CFG_DESCR_LONG)COM_BUF ) -> itf_descr.bInterfaceClass;  // ӿ
                    if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE )// USB洢豸,ȷU
                    {
                        s = CtrlSetUsbConfig( cfg );                   // USB豸
                        if ( s == ERR_SUCCESS )
                        {
                            RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
                            RootHubDev[RootHubIndex].DeviceType = USB_DEV_CLASS_STORAGE;
                            printf( "USB-Disk Ready\n" );
                            SetUsbSpeed( 1 );                          // ĬΪȫ
                            return( ERR_SUCCESS );
                        }
                    }
                    else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ( (PXUSB_CFG_DESCR_LONG)COM_BUF ) -> itf_descr.bInterfaceSubClass <= 0x01 )// HID豸,/
                    {
                        s = AnalyzeHidIntEndp( COM_BUF );             // зHIDж϶˵ĵַ
                        RootHubDev[RootHubIndex].GpVar[0] = s & USB_ENDP_ADDR_MASK ;// ж϶˵ĵַ,λ7ͬ־λ,0
                        if_cls = ( (PXUSB_CFG_DESCR_LONG)COM_BUF ) -> itf_descr.bInterfaceProtocol;
                        s = CtrlSetUsbConfig( cfg );                   // USB豸
                        printf( "HID: %02x",(UINT16)s );
                        if ( s == ERR_SUCCESS )
                        {
                            printf( "GetHIDReport: " );
                            s = CtrlGetHIDDeviceReport();              //ȡ
                            if(s == ERR_SUCCESS)
                            {
                                for ( i = 0; i < 64; i++ )
                                {
                                    printf( "x%02X ", (UINT16)( COM_BUF[i] ) );
                                }
                                printf("\n");
                            }
                            //Set_Idle( );
                            //豣˵ϢԱUSB
                            RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
                            CtrlSetUsbIDLE(0x0a);
                            if ( if_cls == 1 )
                            {
                                RootHubDev[RootHubIndex].DeviceType = DEV_TYPE_KEYBOARD;
                                //һʼ,豸ָʾLED
                                printf( "USB-Keyboard Ready\n" );
                                SetUsbSpeed( 1 );                      // ĬΪȫ
                                return( ERR_SUCCESS );
                            }
                            else if ( if_cls == 2 )
                            {
                                RootHubDev[RootHubIndex].DeviceType = DEV_TYPE_MOUSE;
                                //ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
                                printf( "USB-Mouse Ready\n" );
                                SetUsbSpeed( 1 );                      // ĬΪȫ
                                return( ERR_SUCCESS );
                            }
                            s = ERR_USB_UNSUPPORT;
                        }
                    }
                    else if ( dv_cls == USB_DEV_CLASS_HUB )           // HUB豸,
                    {
                        s = AnalyzeHidIntEndp( COM_BUF );            // зHIDж϶˵ĵַ
                        RootHubDev[RootHubIndex].GpVar[1] = s & USB_ENDP_ADDR_MASK ;// ж϶˵ĵַ,λ7ͬ־λ,0
                        printf( "GetHubDescr: ");
                        s = CtrlGetHubDescr( );
                        if ( s == ERR_SUCCESS )
                        {
                            for( i = 0; i < TxBuffer[0]; i++ )
                            {
                                printf( "x%02X ",(UINT16)(TxBuffer[i]) );
                            }
                            printf("\n");
                            RootHubDev[RootHubIndex].GpVar[0] = ( (PXUSB_HUB_DESCR)TxBuffer ) -> bNbrPorts;// HUBĶ˿
                            if ( RootHubDev[RootHubIndex].GpVar[0] > HUB_MAX_PORTS )
                            {
                                RootHubDev[RootHubIndex].GpVar[0] = HUB_MAX_PORTS;// ΪṹDevOnHubPortʱΪٶÿHUBHUB_MAX_PORTS˿
                            }
                            //if ( ( (PXUSB_HUB_DESCR)TxBuffer ) -> wHubCharacteristics[0] & 0x04 ) printf("мĸ豸\n");
                            //else printf("һļƷ\n");
                            s = CtrlSetUsbConfig( cfg );               // USB豸
                            if ( s == ERR_SUCCESS )
                            {
                                RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
                                RootHubDev[RootHubIndex].DeviceType = USB_DEV_CLASS_HUB;
                                //豣˵ϢԱUSB,ж϶˵HUB¼֪ͨ,ʹòѯ״̬ƴ
                                //HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
                                for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar[0]; i ++ )// HUB˿ڶϵ
                                {
                                    DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_DISCONNECT;  // ⲿHUB˿豸״̬
                                    s = HubSetPortFeature( i, HUB_PORT_POWER );
                                    if ( s != ERR_SUCCESS )
                                    {
                                        printf( "Ext-HUB Port_%1d# power on error\n",(UINT16)i );// ˿ϵʧ
                                    }
                                }
//                             for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar[0]; i ++ ) // HUB˿״̬
//                             {
//                                 s = HubClearPortFeature( i, HUB_C_PORT_CONNECTION );
//                                 if ( s != ERR_SUCCESS )
//                                 {
//                                     printf( "Ext-HUB Port_%1d#  clear connection error\n",(UINT16)i );// ˿״̬ʧ
//                                 }
//                             }
                                for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar[0]; i ++ ) // ѯHUB˿״̬
                                {
                                    s = HubGetPortStatus( i );  // ȡ˿״̬
                                    if ( s != ERR_SUCCESS )
                                    {
                                        printf( "Ext-HUB Port_%1d#	clear connection error\n",(UINT16)i );    // ˿״̬ʧ
                                    }
                                }
                                SetUsbSpeed( 1 );                                        // ĬΪȫ
                                return( ERR_SUCCESS );
                            }
                        }
                    }
                    else                                                                 // Խһ,ֻ
                    {
                        printf("dv_cls=%02x,if_cls =%02x\n",(UINT16)dv_cls,(UINT16)if_cls);
						AnalyzeBulkEndp(COM_BUF , RootHubIndex );
						for(i=0;i!=4;i++)
						{
							printf("%02x ",(UINT16)RootHubDev[RootHubIndex].GpVar[i] );
						}
						printf("\n");						

						s = CtrlSetUsbConfig( cfg );                                     // USB豸
                        if ( s == ERR_SUCCESS )
                        {
							printf("vid pid:%02x %02x\n",(UINT16)RootHubDev[RootHubIndex].DeviceVID,(UINT16)RootHubDev[RootHubIndex].DevicePID);
						
							if((RootHubDev[RootHubIndex].DeviceVID==0x18D1)&&(RootHubDev[RootHubIndex].DevicePID&0xff00)==0x2D00)   //AOA
							{
								printf("AOA Mode\n");
								RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
								RootHubDev[RootHubIndex].DeviceType = DEF_AOA_DEVICE;        //ֻԶı࣬USBЭ
								SetUsbSpeed( 1 );                                            // ĬΪȫ
								return( ERR_SUCCESS );
							}
							else   //AOA ģʽģʽ.
							{
								s = TouchStartAOA();
								if( s == ERR_SUCCESS ) 
								{
									if(touchaoatm<3)         //AOA
									{
										touchaoatm++;
										mDelaymS(500);      //ְ׿豸ԶϿԴ˴ʱ
										continue;           //ʵԲתAOAЭ涨豸Զ½ߡ
									}
									//ִе⣬˵֧ܲAOA豸
									RootHubDev[RootHubIndex].DeviceType = dv_cls ? dv_cls : if_cls;
									RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
									SetUsbSpeed( 1 );                                            // ĬΪȫ
									return( ERR_SUCCESS );                                       // δ֪豸ʼɹ									
								}							
							}							

                        }
                    }
                }
            }
        }
        printf( "InitRootDev Err = %02X\n", (UINT16)s );
        RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_FAILED;
        SetUsbSpeed( 1 );                                                                 // ĬΪȫ
        continue;
    }
    return( s );
}
/*******************************************************************************
* Function Name  : EnumAllRootDevice
* Description    : öROOT-HUB˿ڵUSB豸
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   EnumAllRootDevice( void )
{
    UINT8I   s, RootHubIndex;
    printf( "EnumAllRootDev\n" );
    for ( RootHubIndex = 0; RootHubIndex < 2; RootHubIndex ++ )
    {
        printf( "RootHubIndex %02x\n",(UINT16)RootHubIndex );
        if ( RootHubDev[RootHubIndex].DeviceStatus == ROOT_DEV_CONNECTED )           // ղ豸δʼ
        {
            s = InitRootDevice( RootHubIndex );                                      // ʼ/öָHUB˿ڵUSB豸
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
        }
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : InitDevOnHub
* Description    : ʼöⲿHUBĶUSB豸
* Input          : UINT8 RootHubIndex  ָROOT_HUB
                   UINT8 HubPortIndex  ָⲿHUB
* Output         : None
* Return         : ERR_SUCCESS ɹ
                   ERR_USB_UNKNOWN δ֪豸
*******************************************************************************/
UINT8   InitDevOnHub( UINT8 RootHubIndex, UINT8 HubPortIndex )
{
    UINT8   i, s, cfg, dv_cls, if_cls;
    printf( "Init dev @ExtHub-port_%1d ", (UINT16)HubPortIndex );
    printf( "@Root_%1d\n", (UINT16)RootHubIndex );
    if ( HubPortIndex == 0 )
    {
        return( ERR_USB_UNKNOWN );
    }
    SelectHubPort( RootHubIndex, HubPortIndex );                                      // ѡָROOT-HUB˿ڵⲿHUBָ˿,ѡٶ
    printf( "UH_SETUP = GetDevDescr: %02x",(UINT16)UH_SETUP );
    s = CtrlGetDeviceDescr( );                                                        // ȡ豸
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    dv_cls = ( (PXUSB_DEV_DESCR)COM_BUF ) -> bDeviceClass;                           // 豸
    cfg = ( (RootHubIndex+1)<<4 ) + HubPortIndex;                                     // һUSBַ,ַص
    s = CtrlSetUsbAddress( cfg );                                                     // USB豸ַ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceAddress = cfg;                   // USBַ
    printf( "GetCfgDescr: " );
    s = CtrlGetConfigDescr( );                                                        // ȡ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    cfg = ( (PXUSB_CFG_DESCR)COM_BUF ) -> bConfigurationValue;
    for ( i = 0; i < ( (PXUSB_CFG_DESCR)COM_BUF ) -> wTotalLengthL; i ++ )
    {
        printf( "x%02X ", (UINT16)( COM_BUF[i] ) );
    }
    printf("\n");
    /* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
    if_cls = ( (PXUSB_CFG_DESCR_LONG)COM_BUF ) -> itf_descr.bInterfaceClass;         // ӿ
    if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE )                          // USB洢豸,ȷU
    {
        s = CtrlSetUsbConfig( cfg );                                                  // USB豸
        if ( s == ERR_SUCCESS )
        {
            DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
            DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = USB_DEV_CLASS_STORAGE;
            printf( "USB-Disk Ready\n" );
            SetUsbSpeed( 1 );                                                         // ĬΪȫ
            return( ERR_SUCCESS );
        }
    }
    else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ( (PXUSB_CFG_DESCR_LONG)COM_BUF ) -> itf_descr.bInterfaceSubClass <= 0x01 )    // HID豸,/
    {
        s = AnalyzeHidIntEndp( COM_BUF );                                            // зHIDж϶˵ĵַ
        DevOnHubPort[RootHubIndex][HubPortIndex-1].GpVar = s;                         // ж϶˵ĵַ,λ7ͬ־λ,0
        if_cls = ( (PXUSB_CFG_DESCR_LONG)COM_BUF ) -> itf_descr.bInterfaceProtocol;
        s = CtrlSetUsbConfig( cfg );                                                  // USB豸
        if ( s == ERR_SUCCESS )
        {
            //豣˵ϢԱUSB
            DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
            if ( if_cls == 1 )
            {
                DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = DEV_TYPE_KEYBOARD;
                //һʼ,豸ָʾLED
                printf( "USB-Keyboard Ready\n" );
                SetUsbSpeed( 1 );                                                     // ĬΪȫ
                return( ERR_SUCCESS );
            }
            else if ( if_cls == 2 )
            {
                DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = DEV_TYPE_MOUSE;
                //ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
                printf( "USB-Mouse Ready\n" );
                SetUsbSpeed( 1 );                                                     // ĬΪȫ
                return( ERR_SUCCESS );
            }
            s = ERR_USB_UNSUPPORT;
        }
    }
    else if ( dv_cls == USB_DEV_CLASS_HUB )                                           // HUB豸,
    {
        DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = USB_DEV_CLASS_HUB;
        printf( "This program don't support Level 2 HUB\n");                         // Ҫֶ֧༶HUBοչ
        s = HubClearPortFeature( i, HUB_PORT_ENABLE );                               // ֹHUB˿
        if ( s != ERR_SUCCESS )
        {
            return( s );
        }
        s = ERR_USB_UNSUPPORT;
    }
    else                                                                             // Խһ
    {
        s = CtrlSetUsbConfig( cfg );                                                 // USB豸
        if ( s == ERR_SUCCESS )
        {
            //豣˵ϢԱUSB
            DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
            DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = dv_cls ? dv_cls : if_cls;
            SetUsbSpeed( 1 );                                                        // ĬΪȫ
            return( ERR_SUCCESS );                                                   //δ֪豸ʼɹ
        }
    }
    printf( "InitDevOnHub Err = %02X\n", (UINT16)s );
    DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_FAILED;
    SetUsbSpeed( 1 );                                                                // ĬΪȫ
    return( s );
}
/*******************************************************************************
* Function Name  : EnumHubPort
* Description    : öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼ʼUSB豸
* Input          : UINT8 RootHubIndex ROOT_HUB0ROOT_HUB1
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           ʧ
*******************************************************************************/
UINT8   EnumHubPort( UINT8 RootHubIndex )
{
    UINT8   i, s;
    printf( "EnumHubPort\n" );
    for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar[0]; i ++ )                          // ѯĶ˿Ƿб仯
    {
        SelectHubPort( RootHubIndex, 0 );                                             // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
        s = HubGetPortStatus( i );                                                    // ȡ˿״̬
        if ( s != ERR_SUCCESS )
        {
            return( s );                                                              // ǸHUBϿ
        }
        if ( (( TxBuffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) && ( TxBuffer[2]&(1<<(HUB_C_PORT_CONNECTION&0x07)) ))||(TxBuffer[2] == 0x10) )
        {
            // 豸
            DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_CONNECTED;        // 豸
            DevOnHubPort[RootHubIndex][i-1].DeviceAddress = 0x00;
            s = HubGetPortStatus( i );                                                // ȡ˿״̬
            if ( s != ERR_SUCCESS )
            {
                return( s );                                                          // ǸHUBϿ
            }
            DevOnHubPort[RootHubIndex][i-1].DeviceSpeed = TxBuffer[1] & (1<<(HUB_PORT_LOW_SPEED&0x07)) ? 0 : 1;// ٻȫ
            if ( DevOnHubPort[RootHubIndex][i-1].DeviceSpeed )
            {
                printf( "Found full speed device on port %1d\n", (UINT16)i );
            }
            else
            {
                printf( "Found low speed device on port %1d\n", (UINT16)i );
            }
            mDelaymS( 200 );                                                          // ȴ豸ϵȶ
            s = HubSetPortFeature( i, HUB_PORT_RESET );                               // 豸ӵĶ˿ڸλ
            if ( s != ERR_SUCCESS )
            {
                return( s );                                                          // ǸHUBϿ
            }
            printf( "Reset port and then wait in\n" );
            do                                                                        // ѯλ˿,ֱλ,ɺ״̬ʾ
            {
                mDelaymS( 1 );
                s = HubGetPortStatus( i );
                if ( s != ERR_SUCCESS )
                {
                    return( s );                                                      // ǸHUBϿ
                }
            }
            while ( TxBuffer[0] & (1<<(HUB_PORT_RESET&0x07)) );                       // ˿ڸλȴ
            mDelaymS( 100 );
            s = HubClearPortFeature( i, HUB_C_PORT_RESET );                           // λɱ־
//             s = HubSetPortFeature( i, HUB_PORT_ENABLE );                              // HUB˿
            s = HubClearPortFeature( i, HUB_C_PORT_CONNECTION );                      // ӻƳ仯־
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
            s = HubGetPortStatus( i );                                                // ٶȡ״̬,豸Ƿ
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
            if ( ( TxBuffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) == 0 )
            {
                DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_DISCONNECT;   // 豸
            }
            s = InitDevOnHub( RootHubIndex, i );                                      // ʼUSB豸
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
            SetUsbSpeed( 1 );                                                         // ĬΪȫ
        }
        else if (TxBuffer[2]&(1<<(HUB_C_PORT_ENABLE&0x07))  )                         // 豸ӳ
        {
            HubClearPortFeature( i, HUB_C_PORT_ENABLE );                              // Ӵ־
            printf( "Device on port error\n" );
            s = HubSetPortFeature( i, HUB_PORT_RESET );                               // 豸ӵĶ˿ڸλ
            if ( s != ERR_SUCCESS )
            {
                return( s );    // ǸHUBϿ
            }
            do // ѯλ˿,ֱλ,ɺ״̬ʾ
            {
                mDelaymS( 1 );
                s = HubGetPortStatus( i );
                if ( s != ERR_SUCCESS )
                {
                    return( s );    // ǸHUBϿ
                }
            }
            while ( TxBuffer[0] & (1<<(HUB_PORT_RESET&0x07)) );                       // ˿ڸλȴ
        }
        else if ( ( TxBuffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) == 0 )              // 豸ѾϿ
        {
            if ( DevOnHubPort[RootHubIndex][i-1].DeviceStatus >= ROOT_DEV_CONNECTED )
            {
                printf( "Device on port %1d removed\n", (UINT16)i );
            }
            DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_DISCONNECT;       // 豸
            if ( TxBuffer[2]&(1<<(HUB_C_PORT_CONNECTION&0x07)) )
            {
                HubClearPortFeature( i, HUB_C_PORT_CONNECTION );                      // Ƴ仯־
            }
        }
    }
    return( ERR_SUCCESS );                                                            // زɹ
}
/*******************************************************************************
* Function Name  : EnumAllHubPort
* Description    : öROOT-HUB˿ⲿHUBĶUSB豸
* Input          : None
* Output         : None
* Return         : ERR_SUCCESS ɹ
                           ʧ
*******************************************************************************/
UINT8   EnumAllHubPort( void )
{
    UINT8   s, RootHubIndex;
    printf( "EnumAllHubPort\n" );
    for ( RootHubIndex = 0; RootHubIndex != 2; RootHubIndex ++ )
    {
        if ( RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS && RootHubDev[RootHubIndex].DeviceType == USB_DEV_CLASS_HUB )// HUBöٳɹ
        {
            SelectHubPort( RootHubIndex, 0 );                                         // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
            //ʲô?  HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
//             for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar[0]; i ++ ){                 // ʼHUB˿
//               s = HubSetPortFeature( i, HUB_PORT_POWER );                             // HUB˿ϵ
//               if ( s != ERR_SUCCESS )
//               {
//                 return( s );                                                          // ǸHUBϿ
//               }
//             }
            s = EnumHubPort( RootHubIndex );                                          // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼
            if ( s != ERR_SUCCESS )                                                   // HUBϿ
            {
                printf( "EnumAllHubPort err = %02X\n", (UINT16)s );
            }
            SetUsbSpeed( 1 );                                                         // ĬΪȫ
        }
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : SearchTypeDevice
* Description    : ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
* Input          : UINT8 type 豸
* Output         : None
* Return         : 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
                   ȻҲԸUSBĳVIDƷPID(Ҫ¼豸VIDPID),Լָ
*******************************************************************************/
UINT16  SearchTypeDevice( UINT8 type )
{
    UINT8   RootHubIndex, HubPortIndex;
    for ( RootHubIndex = 0; RootHubIndex != 2; RootHubIndex ++ )                      // ʱԱ豸;γĳЩϢδʱµ
    {
        if ( RootHubDev[RootHubIndex].DeviceType == type && RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS )
        {
            return( (UINT16)RootHubIndex << 8 );                                      // ƥöٳɹ,ROOT-HUB˿
        }
        if ( RootHubDev[RootHubIndex].DeviceType == USB_DEV_CLASS_HUB && RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS )// ⲿHUBöٳɹ
        {
            for ( HubPortIndex = 1; HubPortIndex <= RootHubDev[RootHubIndex].GpVar[0]; HubPortIndex ++ )// ⲿHUBĸ˿
            {
                if ( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType == type && DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus >= ROOT_DEV_SUCCESS )
                {
                    return( ( (UINT16)RootHubIndex << 8 ) | HubPortIndex );           // ƥöٳɹ
                }
            }
        }
    }
    return( 0xFFFF );
}
/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    mInitSTDIO( void )
{
//  SCON = 0x50;
    SM0 = 0;
    SM1 = 1;
    SM2 = 0;
    REN = 1;
    PCON |= SMOD;
    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;                    // 0X20
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                              // *12
    TH1 = 0-13;//0xF3;                                                               /* 12MHz, 4800bps*12=57600bps */
    TR1 = 1;
    TI = 1;
}
/*******************************************************************************
* Function Name  : InitUSB_Host
* Description    : ʼUSB
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Host( void )
{
    UINT8   i;
    IE_USB = 0;
//  LED_CFG = 1;
//  LED_RUN = 0;
    USB_CTRL = bUC_HOST_MODE;                                                       // 趨ģʽ
    USB_DEV_AD = 0x00;
    UH_EP_MOD = bUH_EP_TX_EN | bUH_EP_RX_EN ;
    UH_RX_DMA = RxBuffer;
    UH_TX_DMA = TxBuffer;
    UH_RX_CTRL = 0x00;
    UH_TX_CTRL = 0x00;
    USB_CTRL = bUC_HOST_MODE | bUC_INT_BUSY | bUC_DMA_EN;                           // USBDMA,жϱ־δǰԶͣ
//  UHUB0_CTRL = 0x00;
//  UHUB1_CTRL = 0x00;
    UH_SETUP = bUH_SOF_EN;
    USB_INT_FG = 0xFF;                                                              // жϱ־
    for ( i = 0; i != 2; i ++ )
    {
        DisableRootHubPort( i );                                                    // 
    }
    USB_INT_EN = bUIE_TRANSFER | bUIE_DETECT;
//  IE_USB = 1;                                                                     // ѯʽ
}

void AnalyzeEp()
{
    UINT8 i;
    for(i=0; i<2; i++)
    {
        if(aoaAddr[i]&0x80) //˵˵ķʽ
        {
            aoaEp[0]=aoaAddr[i]&0x0F;
        }
        else
        {
            aoaEp[1]=aoaAddr[i]&0x0F;
        }
        if(adbAddr[i]&0x80) //ķʽ
        {
            adbEp[0]=adbAddr[i]&0x0F;
        }
        else
        {
            adbEp[1]=adbAddr[i]&0x0F;
        }
    }
}

UINT8 adbInput()
{
    UINT8 s;
    UH_RX_CTRL ^= bUH_R_TOG;
    s = USBHostTransact( USB_PID_IN << 4 | adbEp[0], UH_RX_CTRL, 200000/20 );  // IN
    //յRxBuffer
    return s;
}
//adb
UINT8 adbOutput( )
{
    UINT8 s,len=30,buf[30];
	/*
		unsigned char string[30]={"adb shell input keyevent 3"};
	
		printf( "string:" );
		printf( string );
		
		sscanf(string,"%u",buf);
		printf( "buf:" );
		printf( buf);
		*/
	//UINT8C String1[]={0x61,0x64,0x62,0x20,0x73,0x68,0x65,0x6c,0x6c,0x20,0x69,0x6e,0x70,0x75,0x74,0x20,0x6b,0x65,0x79,0x65,0x76,0x65,0x6e,0x74,0x20,0x33};
    UINT8C String1[]={'a','d','b',' ',
		                  's','h','e','l','l',' ',
		                  'i','n','p','u','t',' ',
		                  'k','e','y','e','v','e','n','t',' ',
			                '3'};
	printf( "String1[0]=%c \n",String1[0]);
	memcpy(TxBuffer,&String1,len); //BUF
    UH_TX_LEN = len;
    UH_TX_CTRL ^= bUH_T_TOG;
    s = USBHostTransact( USB_PID_OUT << 4 | adbEp[1], UH_TX_CTRL, 200000/20 );
    return s;
}

main( )
{
    UINT8   i,k,s, len, endp,HUBFlag;
    UINT16  loc;
	UINT8C StringCMD[]={0x61,0x64,0x62,0x20,0x73,0x68,0x65,0x6c,0x6c,0x20,0x69,0x6e,0x70,0x75,0x74,0x20,0x6b,0x65,0x79,0x65,0x76,0x65,0x6e,0x74,0x20,0x33};
    HUBFlag = 0;
    mInitSTDIO( );                                                                  //Ϊüͨڼʾ
    printf( "Start @ChipID=%02X\n", (UINT16)CHIP_ID );
    InitUSB_Host( );
    FoundNewDev = 0;
	  
    printf( "Wait Device In\n" );
    while ( 1 )
    {
        s = ERR_SUCCESS;
        if ( UIF_DETECT )                                                           // USBж
        {
            UIF_DETECT = 0;                                                         // жϱ־
            s = AnalyzeRootHub( );                                                  // ROOT-HUB״̬
            if ( s == ERR_USB_CONNECT )
            {
                FoundNewDev = 1;
            }
        }
        if ( FoundNewDev && s == ERR_USB_CONNECT )                                  // µUSB豸
        {
            FoundNewDev = 0;
            mDelaymS( 200 );                                                        // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
            s = EnumAllRootDevice( );                                               // öROOT-HUB˿ڵUSB豸
            if ( s != ERR_SUCCESS )
            {
                printf( "EnumAllRootDev err = %02X\n", (UINT16)s );
            }
        }
        loc = SearchTypeDevice( DEF_AOA_DEVICE );                               // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
        if ( loc != 0xFFFF )                                                    // ҵ,MOUSEδ?
        {
            //printf("1---loc != 0xFFFF\n");           
		    i = (UINT8)( loc >> 8 );
            len = (UINT8)loc;
            SelectHubPort( i, len );                                            // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
            endp = len ? DevOnHubPort[i][len-1].GpVar : RootHubDev[i].GpVar[0];    // ҵIN˵

            if ( endp & USB_ENDP_ADDR_MASK )                                    // ˵Ч
            {
                //printf("1---endp & USB_ENDP_ADDR_MASK\n"); 
				s = USBHostTransact( USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0 );// CH559,ȡ,NAK
                if ( s == ERR_SUCCESS )
                {
                    printf("2---s == ERR_SUCCESS"); 
					endp ^= 0x80;                                               // ͬ־ת
                    if ( len )
                    {
                        printf("1--- if ( len ) \n"); 
						DevOnHubPort[i][len-1].GpVar = endp;                    // ͬ־λ
                    }
                    else
                    {
                        RootHubDev[i].GpVar[0] = endp;
                    }
                    len = USB_RX_LEN;                                           // յݳ
                    if ( len )
                    {
                        printf("recv data: ");
                        for ( k = 0; k < len; k ++ )
                        {
                            printf("x%02X ",(UINT16)(RxBuffer[k]) );
                        }
                        printf("\n");
                    }
					
					//ش
					memcpy(TxBuffer,RxBuffer,len);                            //ش
					endp = RootHubDev[i].GpVar[2];                            //´˵㷢OUT
					UH_TX_LEN = len; 
					s = USBHostTransact( USB_PID_OUT << 4 | endp & 0x7F, endp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0xffff ); //޴´
					if(s == ERR_SUCCESS)
					{
						printf("2---s == ERR_SUCCESS \n"); 
						endp ^= 0x80;                                       // ͬ־ת  
						RootHubDev[i].GpVar[2] = endp;                         // ͬ־λ						
						printf("send back\n");
					}					

                }
                else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) )
                {
                    printf("transmit error %02x\n",(UINT16)s);                      // ǶϿ
                }
            }
            else
            {
                printf("no interrupt endpoint\n");
            }
            SetUsbSpeed( 1 );                                                    // ĬΪȫ
        }
		mDelaymS( 200 ); 
		//printf("HostCtrlTransfer \n");
		//HostCtrlTransfer(StringCMD,&len);
		printf("adbOutput \n");
		adbOutput();

    }
}
